Dependencies = ["time"]

def execute(macro, args):
    # first, set up some data strucutres
    
    # dow: day of week where 0 = monday
    # nth-dow-in-month: means nth occurance of dow in month, where first occurance is 0
    MEETINGS = {
        "ipswich": {"venue": "The Milestone Beer House", "dow": 0, "nth-dow-in-month": 2, "time": "20:00"},
        "norwich": {"venue": "The Reindeer", "dow": 3, "nth-dow-in-month": 1, "time": "20:00"}
        }

    # default value(s)
    show_venue = False
    
    # second, process the args string
    args_list = [s.strip() for s in args.split(",")]

    # iterate over the arguments and an argument counter, n
    for (arg, n) in zip(args_list, range(len(args_list))):
        # arg could be "name=value" or just "value"
        # assign values to arg_name and arg_value
        if arg.find("=") >= 0:
            arg_name = arg[:arg.index("=")].strip().upper()
            arg_value = arg[arg.index("=")+1:].strip()
        else:
            arg_name = None
            arg_value = arg.strip()

        # first argument: meeting location
        if arg_name == "LOCATION" or n == 0:
            if arg_value.upper() == "IPSWICH":
                location = "ipswich"
            elif arg_value.upper() == "NORWICH":
                location = "norwich"
            else:
                return macro.formatter.text("")

        if arg_name == "SHOW_VENUE" or n == 1:
            show_venue = arg_value.upper() in ["YES", "Y", "1"]
                
        # additional arguments would be caught thus:
        #if arg_name == "ARGUMENT_NAME" or n == 1:

    # third, process the given argument(s)
    import datetime

    today = datetime.datetime.now()
    year = today.year
    month = today.month

    def get_next_meeting_day(month, year):
        # establish the number of days from the first of the month
        # to the first occurence of the day of the week on which the
        # meeting falls
        fom = datetime.datetime(year,month,1)
        fom_to_fdow = MEETINGS[location]["dow"] - fom.weekday()
        if fom_to_fdow < 0:
            fom_to_fdow = 7 + fom_to_fdow

        return fom_to_fdow + (7 * MEETINGS[location]["nth-dow-in-month"]) + 1

    if get_next_meeting_day(month, year) < today.day:
        month += 1
        if month > 12:
            year += 1
            month = 1

    date_of_next_meet = datetime.datetime(year, month, get_next_meeting_day(month, year))

    if show_venue:
        return macro.formatter.text("%s %s @ %s" %\
                (MEETINGS[location]["time"], date_of_next_meet.strftime("%A %d %B %Y"), MEETINGS[location]["venue"]))
    else:
        return macro.formatter.text("%s %s" %\
                (MEETINGS[location]["time"], date_of_next_meet.strftime("%A %d %B %Y")))

